.TH mipdiag 8 "25 April 2000" "@VERSION@"
.SH NAME
mipdiag \- MIPL Mobile IPv6 diagnostics and configuration tool
.SH SYNOPSIS
.B mipdiag [-acls?] [-M keymd5] [-S keysha1] [-h 
.I ipv6-address/prefix-length
.B ] [-H 
.I ipv6-address/prefix-length
.B ] [-d
.I integer
.B ] [-r
.I access-control-rule
.B ] [-R
.I filename
.B ] [-t
.I boolean
.B ]
.SH DESCRIPTION
.B mipdiag
is diagnostics and configuration tool for MIPL Mobile IPv6 kernel
module. You can get statistics and state information with it and set
runtime parameters.
.SH OPTIONS
.IP "-a, --access"
Print current access control list
.IP "-c, --bcache"
Print binding cache entries
.IP "-l, --bulist"
Print binding update list entries
.IP "-s, --statistics"
Show general statistics
.IP "-?, --help"
Show usage information
.IP "-d, --debuglevel integer"
Set debug level to integer. Levels from 0 to 7 exist. Default: 0.
.IP "-h, --homeaddress ipv6-address/prefix-length"
Set mobile node's home address to ipv6-address.
.IP "-H, --homeagent ipv6-address/prefix-length"
Set mobile node's home agent address to ipv6-address.
.IP "-r, --rule acl-rule"
Set access control rule.
.IP "-R, --rulelist filename"
Read access control rules from filename.
.IP "-S filename"
Read security associations for authentication of Mobile IPv6 signaling
from filename. If a filename is not given, mipdiag tries to read SAs
from /etc/mipv6_sas.conf.
.IP "-t, --tunnel_sitelocal boolean"
Set option whether site-local packets to mobile node should be tunneled. Default: yes.
.IP "--showsa address"
Prints the security association(s) for the address to the console (or kernel log). If no address is specified prints all security associations.
.IP "--delsa address"
Deletes the security association(s) for the address.
.SH EXAMPLES
.SH BUGS
No known bugs.
.SH FILES
.I @sysconfdir@/network-mip6.conf
.RS
Mobile IPv6 main configuration file
.RE
.I @sysconfdir@/mipv6_acl.conf
.RS
Mobile IPv6 Access control file for home agent
.RE
.I @sysconfdir@/mipv6_sas.conf
.RS 
The security associations for authentication of mipv6 signaling.
.SH AUTHOR
Antti J Tuominen <ajtuomin@tml.hut.fi>
.SH "SEE ALSO"
.BR network-mip6.conf(5),
.BR mipv6_acl.conf(5),
.BR mipv6_sas.conf(5)
