.TH mipv6_acl.conf 5 "25 April 2000" "@VERSION@"
.SH NAME
mipv6_acl.conf \- MIPL Mobile IPv6 access control list file
.SH DESCRIPTION
.B mipv6_acl.conf
is the mobile node access control file. This file is normally used by
mipdiag(8). It contains a set of rules according to which the home
agent restricts mobile node access.

Rule list is read from top to bottom and the first matching rule is
used. If ACL contains no rules all mobile nodes are allowed to
register. If ACL has one or more rules implicit DENY ::/0 (all) is
used as last line. When using DENY only ACL explicit ALLOW ::/0 (all)
is required. When allowing or denying single nodes use 128 as prefix
length. 

.SH RULES
.IP "FLUSH"
This rule empties the whole list. When list is empty all nodes are
allowed to register. FLUSH should only be used as the first
rule. FLUSH has no arguments.
.IP "ALLOW ipv6-address/plen"
ALLOW rule lets nodes with matching prefix to register. Mobile node's
address is compared to 
.B ipv6-address 
using the 
.B plen 
first bits.
.IP "DENY ipv6-address/plen"
DENY rule blocks registration from nodes with matching prefix. Mobile node's
address is compared to 
.B ipv6-address 
using the 
.B plen 
first bits.

.SH EXAMPLES

Allow only nodes 3ffe:2620:6:1234:abcd::1 and 3ffe:2620:6:1234:abcd::2
to register.
.PP
  ALLOW 3ffe:2620:6:1234:abcd::1/128
  ALLOW 3ffe:2620:6:1234:abcd::2/128
.PP

Allow whole 3ffe:2620:6:1234:: network to register except
3ffe:2620:6:1234:abcd::.
.PP
  DENY 3ffe:2620:6:1234:abcd::/80
  ALLOW 3ffe:2620:6:1234::/64
.PP

Just deny 3ffe:2620:: and let the rest register.
.PP
  DENY 3ffe:2620::/32
  ALLOW ::/0
.PP
.SH AUTHOR
Antti J Tuominen <ajtuomin@tml.hut.fi>
.SH "SEE ALSO"
.BR mipdiag(8)
