.TH network-mip6.conf 5 "25 April 2000" "@VERSION@"
.SH NAME
network-mip6.conf \- MIPL Mobile IPv6 main configuration file
.SH DESCRIPTION
.B network-mip6.conf
is the main configuration file for MIPL Mobile IPv6 kernel
module. This file is used by automatic startup script to set up
parameters for the kernel module.
.SH SYNTAX
Configuration file consists of option and value pairs: OPTION=value. Option name must be in all capitals. Value is case-insensitive.
.SH OPTIONS
.IP "FUNCTIONALITY"
Should this node act as a home agent (ha), mobile node (mn) or
correspondent node (cn). HA and MN both have CN functionality
embedded. Default: cn.
.IP "DEBUGLEVEL"
In error situations it may be desired to get more detailed
information what is happening. Increase this value to get more
messages from the module (default: 0).
.IP "TUNNEL_SITELOCAL"
Should unicasts to node's site-local address be tunneled when mobile
node is not in its home network (default: yes).
.IP "HOMEADDRESS"
Home address for mobile node with prefix length. Example:
3FFE:2620:6:1234:ABCD::1/48 (Don't use the example value!)
.IP "HOMEAGENT"
Home agent's address for mobile node. 
.IP "MD5KEY"
The 128-bit hmac md5 key of 22 alphanumeric characters to be used with AH. 
Either MD5KEY ot SHA1KEY can be used for AH. 
.IP "SHA1KEY"
The 168-bit hmac sha1 key of 27 alphanumeric characters to be used with AH.
.IP "MOBILENODEFILE"
Path for a file containing list of IPv6 addresses (and other
information) of mobile nodes for which this node is allowed to act
as a home agent.
.IP "RTR_SOLICITATION_INTERVAL"
Mobile nodes are allowed to send Router Solicitation messages at a
shorter minimum interval than normal IPv6 nodes (default: 4
seconds). This value controls the mobile nodes minimum Router
Solicitation interval in seconds (default: 1).
.IP "RTR_SOLICITATION_MAX_SENDTIME"
After sending MAX_RTR_SOLICITATIONS (defined by IPv6, default: 3)
mobile node reduces Router Solicitation send rate with binary
exponential back-off mechanism until the maximum send time limit is
reached. This option sets the maximum send time in seconds.
.SH EXAMPLES
.PP
  # Home Agent configuration file
  FUNCTIONALITY=ha
  DEBUGLEVEL=0
  TUNNEL_SITELOCAL=yes
  MOBILENODEFILE=/etc/mipv6_acl.conf

  # Mobile Node configuration file
  FUNCTIONALITY=mn
  DEBUGLEVEL=1
  HOMEADDRESS=3ffe:2620:6:1234:abcd::2/64
  HOMEAGENT=3ffe:2620:6:1234:abcd::1/64
  RTR_SOLICITATION_INTERVAL=1
  RTR_SOLICITATION_MAX_SENDTIME=5
.PP
.SH FILES
.I @sysconfdir@/mipv6_acl.conf
.RS
Mobile IPv6 Access control file for home agent
.RE
.SH AUTHOR
Antti J Tuominen <ajtuomin@tml.hut.fi>
.SH "SEE ALSO"
.BR mipdiag(8),
.BR mipv6_acl.conf(5)
